# coding: utf-8

"""
    Ringer Business API

    This API provides comprehensive endpoints for the Ringer Business system. It includes functionality for managing customer accounts, addresses, sites, phone numbers, payments, users, and other business resources.  Operations typically require authentication and appropriate permissions. 

    The version of the OpenAPI document: 1.0.6
    Contact: support@ringer.tel
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class UserFeatureRequestFeatures(BaseModel):
    """
    List of feature codes to enable for the user.
    """ # noqa: E501
    devices: Optional[List[StrictInt]] = None
    voice_mail_boxes: Optional[List[StrictInt]] = None
    ring_groups: Optional[List[StrictInt]] = None
    extensions: Optional[List[StrictInt]] = None
    phone_numbers: Optional[List[StrictInt]] = None
    conference_rooms: Optional[List[StrictInt]] = None
    fax_machines: Optional[List[StrictInt]] = None
    forwards: Optional[List[StrictInt]] = None
    schedules: Optional[List[StrictInt]] = None
    __properties: ClassVar[List[str]] = ["devices", "voice_mail_boxes", "ring_groups", "extensions", "phone_numbers", "conference_rooms", "fax_machines", "forwards", "schedules"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UserFeatureRequestFeatures from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UserFeatureRequestFeatures from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "devices": obj.get("devices"),
            "voice_mail_boxes": obj.get("voice_mail_boxes"),
            "ring_groups": obj.get("ring_groups"),
            "extensions": obj.get("extensions"),
            "phone_numbers": obj.get("phone_numbers"),
            "conference_rooms": obj.get("conference_rooms"),
            "fax_machines": obj.get("fax_machines"),
            "forwards": obj.get("forwards"),
            "schedules": obj.get("schedules")
        })
        return _obj


